# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

Public Member Functions | Protected Attributes

# vl::LightModel Class Reference

RenderState wrapping the OpenGL function glLightModel(), see also http://www.opengl.org/sdk/docs/man/xhtml/glLightModel.xml for more information. More...

`#include <Shader.hpp>`

Inheritance diagram for vl::LightModel:

List of all members.

## Public Member Functions

| LightModel ()
virtual ERenderState | type () const
virtual void | apply (int index, const Camera *, OpenGLContext *ctx) const
| The parameter cameara is NULL if we are disabling the state, non-NULL if we are enabling it.
void | setLocalViewer (bool localviewer)
void | setTwoSide (bool twoside)
void | setColorControl (EColorControl colorcontrol)
void | setAmbientColor (fvec4 ambientcolor)
bool | localViewer () const
bool | twoSide () const
EColorControl | colorControl () const
fvec4 | ambientColor () const
virtual ref< RenderState > | clone () const

## Protected Attributes

fvec4 | mAmbientColor
EColorControl | mColorControl
bool | mLocalViewer
bool | mTwoSide

## Detailed Description

RenderState wrapping the OpenGL function glLightModel(), see also http://www.opengl.org/sdk/docs/man/xhtml/glLightModel.xml for more information.

See also:
  Shader, Effect, Actor, vl::EN_LIGHTING

Definition at line 859 of file Shader.hpp.

## Constructor & Destructor Documentation

vl::LightModel::LightModel | ( | ) | `[inline]`

Definition at line 864 of file Shader.hpp.

References VL_DEBUG_SET_OBJECT_NAME.

## Member Function Documentation

virtual ERenderState vl::LightModel::type | ( | ) | const`[inline, virtual]`

Reimplemented from vl::RenderState.

Definition at line 869 of file Shader.hpp.

References vl::RS_LightModel.

void LightModel::apply | ( | int | index,
|  | const Camera * | camera,
|  | OpenGLContext * | ctx
| ) |  | const`[virtual]`

The parameter cameara is NULL if we are disabling the state, non-NULL if we are enabling it.

Implements vl::RenderState.

Definition at line 524 of file Shader.cpp.

References vl::Has_GL_Version_1_1, vl::Has_GL_Version_1_2, mAmbientColor, mColorControl, mLocalViewer, mTwoSide, vl::Vector4< T_Scalar >::ptr(), and VL_CHECK_OGL.

void vl::LightModel::setLocalViewer | ( | bool | localviewer ) | `[inline]`

Definition at line 873 of file Shader.hpp.

void vl::LightModel::setTwoSide | ( | bool | twoside ) | `[inline]`

Definition at line 875 of file Shader.hpp.

void vl::LightModel::setColorControl | ( | EColorControl | colorcontrol ) | `[inline]`

Definition at line 877 of file Shader.hpp.

void vl::LightModel::setAmbientColor | ( | fvec4 | ambientcolor ) | `[inline]`

Definition at line 879 of file Shader.hpp.

bool vl::LightModel::localViewer | ( | ) | const`[inline]`

Definition at line 881 of file Shader.hpp.

bool vl::LightModel::twoSide | ( | ) | const`[inline]`

Definition at line 883 of file Shader.hpp.

EColorControl vl::LightModel::colorControl | ( | ) | const`[inline]`

Definition at line 885 of file Shader.hpp.

fvec4 vl::LightModel::ambientColor | ( | ) | const`[inline]`

Definition at line 887 of file Shader.hpp.

virtual ref<RenderState> vl::LightModel::clone | ( | ) | const`[inline, virtual]`

Implements vl::RenderState.

Definition at line 889 of file Shader.hpp.

## Member Data Documentation

fvec4 vl::LightModel::mAmbientColor`[protected]`

Definition at line 897 of file Shader.hpp.

Referenced by apply().

EColorControl vl::LightModel::mColorControl`[protected]`

Definition at line 898 of file Shader.hpp.

Referenced by apply().

bool vl::LightModel::mLocalViewer`[protected]`

Definition at line 899 of file Shader.hpp.

Referenced by apply().

bool vl::LightModel::mTwoSide`[protected]`

Definition at line 900 of file Shader.hpp.

Referenced by apply().

The documentation for this class was generated from the following files:

- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/Shader.hpp
- D:/VL/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGraphics/Shader.cpp

Visualization Library v2011.09.1162 Reference Documentation
Copyright 2005-2011 Michele Bosi. All rights reserved.
Updated on Thu Jan 26 2012 00:44:52.
Permission is granted to use this page to write and publish articles regarding Visualization Library.